program pick_it
  ! Velocity transform
	use solver_mod
	use cgstep_mod
  use sep
  use lap_mod
  use weight
  use nl_solver
  use solver_mod
 use igrad2
  implicit none
  integer                          ::  n2, niter, stat,n1
  real                             ::o1,d1, o2,d2,hcut,eps,pow
  real, dimension (:), pointer     :: data, model, error,wt
  character(len=128) :: label

  call sep_init (SOURCE) ! start processing parameters
  call sep_get_data_axis_par("in",1,n1,o1,d1,label)
  call sep_get_data_axis_par("in",2,n2,o2,d2,label)
	call from_param("niter",niter,50)
	call from_param("pow",pow,3.)
	call from_param("eps",eps,1.)
	allocate(data(n1*n2),model(n1*n2),wt(n1*n2))
  call sreed("in",data,size(data)*4)
  call sreed("in",wt,size(wt)*4)
  call ds_init()
  wt=wt**pow
  call weight_init(wt)
!  call lap_init(n1,n2)
  call igrad2_init(n1,n2)
  call from_param("hcut",hcut,10.)
  call to_history("n3",1)
  data=data*wt
   call srite("ab.H",data,size(data)*4)
!  call nlcg_huber (weight_lop,hcut,model,data,niter,reg=lap_op,nreg=size(model))
!  call solver_reg(weight_lop,cgstep,lap_op,size(model),model,data,niter,eps,verb=.true.);
  call solver_reg(weight_lop,cgstep,igrad2_lop,size(model)*2,model,data,niter,eps,verb=.true.);
  call srite("out",model,size(model)*4)
  deallocate (model,data,wt)
  call exit (0)
end program pick_it
