#<
#dip_field
#
#Usage:
#dip_field.x  <in.H >out.H 
#
#Input Parameters:
#
#
#Output Parameters:
#
#
#
#Description:
#
#
#
#>
#%end of self-documentaiton
#-------------------------------------------------
#
#Author: Robert Clapp, ESMB 463, 7230253
#
#Date Created:Mon May 21 15:10:48 PDT 2001
#
#Purpose: 
#

module pts_mod{ 
  use stat_mod
  use puck_mod
	use quantile_mod
  use calc_semblance_mod
  use sort_subs_mod
  use tomo_space_conv_mod
  use slope_dir_mod
use random
use sep3d_struct_mod
!use data_var_mod

type(sep3d),private,save :: semb,wt,cut,mig,vel,dips_xz,dips_yz,vel_conv,velz_s
logical,private,save     :: verb,redid
real   , private, save   :: max_rms_err_pct
integer, private, save   :: n_d_rms_semb
integer, private, save   :: nsmooth_semb,nsect_dip_coher
real,    private, save   :: pct_keep_semb,pct_keep_image,min_keep_semb
real,    private, save   :: min_dip_coher,max_dip_coher
integer, private, save   :: nsmooth_dips(3),nwind_dips(3),min_pts_dist(3)
real,    private, save,allocatable    :: pxzt_field(:), pyzt_field(:),semb_field(:),p_xz(:),p_yz(:)
real,    private, save,allocatable    :: wt_field(:),pts_field(:,:),cut_field(:)
integer, private, save   :: npts
logical, private, save   :: is_2d



contains

subroutine clean_pts(){
deallocate(pxzt_field,semb_field,p_xz,wt_field,pts_field,cut_field)
if(.not. is_2d) deallocate(pyzt_field,p_yz)
}

logical function redid_pts_file(){
redid_pts_file=redid
}




logical function init_pts(){
integer, external :: auxin,sreed,sep_get_val_headers
integer :: nv(3)
real :: o(3),d(3),ov(3),dv(3)
real,allocatable :: temp1_2(:,:),temp2_2(:,:),temp1_3(:,:,:),temp2_3(:,:,:),temp1_1(:),temp2_1(:)
real,allocatable :: temp3_2(:,:),temp4_2(:,:),temp3_3(:,:,:),temp4_3(:,:,:),myvel(:)
integer :: n(3),i2,i1,iloc(3),i3
integer, external :: getch
real :: dt_z,rand_scale
logical :: tau,log
real :: pos(3)
	


init_pts=.false.

#grab the velocity model
if(.not. vel_tomo_structure(vel_conv)){
  write(0,*) "could not grab converted velocity structure"
  return
}
if(.not. vel_structure(vel)){
  write(0,*) "could not grab velocity structure"
  return
}

if(.not. vel_z_tomo_structure(velz_s)){
  write(0,*) "trouble getting velz structure"
  return
}



if(sep3d_ndims(vel)==2) is_2d=.true.
else is_2d=.false.

if(-1==auxin("cut")) { write(0,*) "Must provide cut function";return;}
else call auxclose("cut")
call init_sep3d("cut",cut,"INPUT")
if(sep3d_ndims(cut)!=1){
	write(0,*) "expecting a 1-D cut function",cut%ndims
  return
}
allocate(cut_field(product(cut%n(1:sep3d_ndims(cut)))))
if(size(cut_field)*4!=sreed("cut",cut_field,size(cut_field)*4)){
	write(0,*) "trouble reading cut field"
  return
}

if(-1==auxin("mig")){
 write (0,*) "must provide mig tag"
 return
}

call init_sep3d("mig",mig,"INPUT")

allocate(myvel(product(vel%n(1:sep3d_ndims(vel)))))
if(.not. vel_1d(myvel))
	call erexit("trouble retrieving velocity")
nv=1;nv(1:sep3d_ndims(vel))=vel%n(1:sep3d_ndims(vel))
ov=0;ov(1:sep3d_ndims(vel))=vel%o(1:sep3d_ndims(vel))
dv=1;dv(1:sep3d_ndims(vel))=vel%d(1:sep3d_ndims(vel))



#grab the parameters
if(.not. grab_pts_params()){
	write(0,*) "could not grab pts parameters"
  return
}

call init_semb(ov,dv,reshape(myvel,(/nv(1),nv(2),nv(3)/)),
  max_rms_err_pct,n_d_rms_semb,
 nsmooth_semb,cut_field,mig%n(1:2),mig%o(1:2),mig%d(1:2))

#o_d_rms_semb,d_d_rms_semb,vel%o,vel%d,
#  reshape(myvel,(/nv(1),nv(2),nv(3)/)),
#  mig%o(1:2),mig%d(1:2),mig%n(1:2),nsmooth_semb,cut_field)

deallocate(myvel)

#check to see if parameters are different
  redid=.false.
if(.not. check_params()){
  redid=.true.
	if(.not. write_params()){
		write(0,*) "trouble writing parameters"
    return
	}
  
	#calculate the dips field
  npts=0
  if(.not. calc_dip_field(npts)){
		write(0,*) "trouble calculating dip field"
		return;
	}

  if(.not. calc_semblance_at_pts(npts)){
		write(0,*) "trouble calcucating at selected pts"
    return;
	}
	call sep3df_delete(semb)
	call sep3df_delete(wt)
	call sep3df_delete(dips_xz)
  if(.not. is_2d) call sep3d_delete("dips_yz")
}
call init_sep3d("semb",semb,"INPUT")
allocate(semb_field(semb%n(2))); 
if(size(semb_field)*4!=sreed("semb",semb_field,4*size(semb_field)))
	call erexit("trouble reading in semblance")

call init_sep3d("dips_xz",dips_xz,"INPUT")
allocate(pxzt_field(product(dips_xz%n(1:sep3d_ndims(dips_xz)))))
if(size(pxzt_field)*4!=sreed("dips_xz",pxzt_field,4*size(pxzt_field)))
	call erexit("trouble reading in dips_xz")
if(.not. is_2d){
	 call init_sep3d("dips_yz",dips_yz,"INPUT")
	allocate(pyzt_field(product(dips_yz%n(1:sep3d_ndims(dips_yz)))))
	if(size(pyzt_field)*4!=sreed("dips_yz",pyzt_field,4*size(pyzt_field)))
		call erexit("trouble reading in dips_yz")

}
call init_sep3d("wt",wt,"INPUT")
allocate(wt_field(wt%n(2))); 
if(size(wt_field)*4!=sreed("wt",wt_field,4*size(wt_field)))
	call erexit("trouble reading in wts")

allocate(pts_field(4,wt%n(2)))
if(0!=sep_get_val_headers("wt",1,wt%n(2),pts_field))
	call erexit("trouble reading in pts field")



o=0;d=1;n=1;
o(3)=vel%o(1);d(3)=vel%d(1); n(3)=vel%n(1)
o(1:sep3d_ndims(vel)-1)=vel%o(2:sep3d_ndims(vel))
d(1:sep3d_ndims(vel)-1)=vel%d(2:sep3d_ndims(vel))
n(1:sep3d_ndims(vel)-1)=vel%n(2:sep3d_ndims(vel))

if(1==getch("semb_plot","d",i3)){
#NOW LETS MAKE A MAP OF THE SEMBLANCE VALUES
allocate(temp1_3(nv(1),nv(2),nv(3)),temp1_1(size(pts_field,2)))
allocate(temp2_3(nv(1),nv(2),nv(3)),temp2_1(size(pts_field,2)))
allocate(temp3_3(nv(1),nv(2),nv(3)))
call sep_put_data_axis_par("var_plot",1,nv(1),ov(1),dv(1),"depth")
call sep_put_data_axis_par("var_plot",2,nv(2),ov(2),dv(2),"X Position")
call sep_put_data_axis_par("var_plot",3,nv(3),ov(3),dv(3),"Y Position")
call sep_put_data_axis_par("semb_plot",1,nv(1),ov(1),dv(1),"depth")
call sep_put_data_axis_par("semb_plot",2,nv(2),ov(2),dv(2),"X Position")
call sep_put_data_axis_par("semb_plot",3,nv(3),ov(3),dv(3),"Y Position")
call sep_put_data_axis_par("semb_new",1,nv(1),ov(1),dv(1),"depth")
call sep_put_data_axis_par("semb_new",2,nv(2),ov(2),dv(2),"X Position")
call sep_put_data_axis_par("semb_new",3,nv(3),ov(3),dv(3),"Y Position")



  

do i3=1,nv(3){
	pos(3)=ov(3)+dv(3)*i3
  do i2=1,nv(2){
	  pos(2)=ov(2)+dv(2)*i2
		do i1=1,nv(1){
			pos(1)=ov(1)+dv(1)*i1
      temp1_1(:)=(pos(1)-pts_field(3,:))**2+ (pos(2)-pts_field(1,:))**2+
        (pos(3)-pts_field(2,:))**2
      temp1_3(i1,i2,i3)=sum(semb_field/temp1_1**3)/sum(1./temp1_1**3)
      temp2_3(i1,i2,i3)=sum(pts_field(4,:)/temp1_1**3)/sum(1./temp1_1**3)
		}
	}
}
 do i1=1,size(pts_field,2){
   pos=((/pts_field(3,i1),pts_field(1,i1),pts_field(2,i1)/)-
       ov)/dv+1.
   iloc=min(nv,max(1,nint(pos)))
   temp2_1(i1)=random_normal()*sqrt(temp2_3(iloc(1),iloc(2),iloc(3)))
	 log=moveout_dt(pts_field(:3,i1),temp2_3(iloc(1),iloc(2),iloc(3)),
     20.,pts_field(4,i1),.false.,.true.)
  }

call srite("semb_plot",temp1_3,size(temp1_3)*4)

do i3=1,nv(3){
	pos(3)=ov(3)+dv(3)*i3
  do i2=1,nv(2){
	  pos(2)=ov(2)+dv(2)*i2
		do i1=1,nv(1){
			pos(1)=ov(1)+dv(1)*i1
      temp1_1(:)=(pos(1)-pts_field(3,:))**2+ (pos(2)-pts_field(1,:))**2+
        (pos(3)-pts_field(2,:))**2
      temp3_3(i1,i2,i3)=sum(temp2_1/temp1_1**3)/sum(1./temp1_1**3)
      temp2_3(i1,i2,i3)=sum(pts_field(4,:)/temp1_1**3)/sum(1./temp1_1**3)

    }
  }
}

 
call from_param('rand_scale_top',rand_scale,0.)
 semb_field+=temp2_1*rand_scale



call srite("var_plot",temp2_3,size(temp2_3)*4)
call srite("semb_new",temp3_3,size(temp3_3)*4)
deallocate(temp1_3,temp1_1,temp2_3,temp3_3,temp2_1)
    
}



npts=size(pts_field,2)
allocate(p_xz(npts))
if(.not. is_2d) allocate(p_yz(npts))
do i2=1,size(pts_field,2){
	iloc=max(1,min(n,nint((pts_field(1:3,i2)-o)/d+1.)))
  i1=iloc(3)+(iloc(1)-1)*n(3)+(iloc(2)-1)*n(1)*n(3)
	p_xz(i2)=pxzt_field(i1)
	if(.not. is_2d) p_yz(i2)=pyzt_field(i1)
}


call from_param("tau",tau,.false.)
if(tau){
#if 2d
if(is_2d){

	allocate(temp1_2(velz_s%n(1),velz_s%n(2)))
	allocate(temp2_2(velz_s%n(1),velz_s%n(2)))
	allocate(temp3_2(velz_s%n(1),velz_s%n(2)))
	#grab the map
	if(.not.vel_tomo_2d(mymapz=temp1_2)){
		write(0,*) "trouble obtaining mymapz"
		return
	}
	#convert the pxzt_field to 2-D
	temp2_2= reshape(pxzt_field,(/velz_s%n(1),velz_s%n(2)/))
	deallocate(pxzt_field)	
		

#  call srite("fewd.H",temp1_2,size(temp1_2)*4)
#  call srite("fewd.H",temp2_2,size(temp2_2)*4)

	#convert dip field to tau in in z coordinates
	#
	# dt     dz   dt
	# --  =  --   --
	# dx     dx   dz
	#
	do i1=2,velz_s%n(1){
		temp3_2(i1,:)=temp2_2(i1,:)*(temp1_2(i1,:)-temp1_2(i1-1,:))/vel%d(1)
	}
	temp3_2(1,:)=temp3_2(2,:)

		
	deallocate(temp1_2,temp2_2)
	
  #remap field to z
	allocate(temp1_2(vel_conv%n(1),vel_conv%n(2)))
!  call srite("fewd.H",temp3_2,size(temp3_2)*4)
	call convert_field_z_tau_2d(temp3_2,temp1_2)
!  call srite("newd.H",temp1_2,size(temp1_2)*4)
	allocate(pxzt_field(product(vel_conv%n(1:2))))
	pxzt_field=reshape(temp1_2,(/size(pxzt_field)/))
	deallocate(temp1_2,temp3_2)
!  call srite("newd.H",pxzt_field,size(pxzt_field)*4)
	call sep3df_delete(dips_xz)
	call init_sep3d(vel_conv,dips_xz,"SCRATCH")
}
else{
#if 3d
	allocate(temp1_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	allocate(temp2_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	allocate(temp3_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	#grab the map
	if(.not.vel_tomo_3d(mymapz=temp1_3)){
		write(0,*) "trouble obtaining mymapz"
		return
	}
	#convert the pxzt_field to 2-D
	temp2_3= reshape(pxzt_field,(/velz_s%n(1),velz_s%n(2),velz_s%n(3)/))
	deallocate(pxzt_field)	
	do i1=2,velz_s%n(1)
		temp3_3(i1,:,:)=temp2_3(i1,:,:)*
     (temp1_3(i1,:,:)-temp1_3(i1-1,:,:))*vel_conv%d(1)/vel%d(1)
	temp3_3(1,:,:)=temp3_3(2,:,:)
		
	deallocate(temp1_3,temp2_3)
  #remap field to z
	allocate(temp1_3(vel_conv%n(1),vel_conv%n(2),vel_conv%n(3)))
	call convert_field_z_tau_3d(temp3_3,temp1_3)
	allocate(pxzt_field(product(vel_conv%n(1:3))))
	pxzt_field=reshape(temp1_3,(/size(pxzt_field)/))
	deallocate(temp1_3,temp3_3)

	allocate(temp1_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	allocate(temp2_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	allocate(temp3_3(velz_s%n(1),velz_s%n(2),velz_s%n(3)))
	#grab the map
	if(.not.vel_tomo_3d(mymapz=temp1_3)){
		write(0,*) "trouble obtaining mymapz"
		return
	}
	#convert the pxzt_field to 2-D
  temp2_3=
    reshape(pyzt_field,(/velz_s%n(1),velz_s%n(2),velz_s%n(3)/))
	deallocate(pyzt_field)	
	do i1=2,velz_s%n(1)
		temp3_3(i1,:,:)=temp2_3(i1,:,:)*
     (temp1_3(i1,:,:)-temp1_3(i1-1,:,:))*vel_conv%d(1)/vel%d(1)
	temp3_3(1,:,:)=temp3_3(2,:,:)
		
	deallocate(temp1_3,temp2_3)
  #remap field to z
	allocate(temp1_3(vel_conv%n(1),vel_conv%n(2),vel_conv%n(3)))
	call convert_field_z_tau_3d(temp3_3,temp1_3)
	allocate(pyzt_field(product(vel_conv%n(1:3))))
	pyzt_field=reshape(temp1_3,(/size(pxzt_field)/))
	deallocate(temp1_3,temp3_3)
	call sep3df_delete(dips_xz)
	call sep3df_delete(dips_yz)
	call init_sep3d(vel_conv,dips_xz,"SCRATCH")
	call init_sep3d(vel_conv,dips_yz,"SCRATCH")
}
}
	
	

if(-1==auxin("cut")){
	write(0,*) "unable to obtain cut function"
	return
}
else call auxclose("cut")


#call sep3df_delete(velz_s)

init_pts=.true.
}

logical function return_semb_3d(mypts,mysemb,mydipxz,mydipyz,mydip_field_xzt,mydip_field_yzt,mywt){
real,optional :: mypts(:,:),mysemb(:),mydip_field_xzt(:,:,:)
real,optional :: mydip_field_yzt(:,:,:),mywt(:),mydipxz(:),mydipyz(:)

if(present(mypts)) mypts(1:3,:)=pts_field(1:3,:)
if(present(mysemb)) mysemb=semb_field
if(present(mydipxz)) mydipyz=p_xz
if(present(mydipyz)) mydipyz=p_yz
if(present(mydip_field_xzt)) mydip_field_xzt=reshape(pxzt_field,(/dips_xz%n(1),dips_xz%n(2),dips_xz%n(3)/))
if(present(mydip_field_yzt)) mydip_field_yzt=reshape(pyzt_field,(/dips_yz%n(1),dips_yz%n(2),dips_yz%n(3)/))
if(present(mywt)) mywt=wt_field
return_semb_3d=.true.
}



logical function return_semb_2d(mypts,mysemb,mydipxz,mydip_field_xzt,mywt){
real,optional :: mypts(:,:),mysemb(:),mydip_field_xzt(:,:)
real,optional :: mywt(:),mydipxz(:)

if(present(mypts)) mypts(1:2,:)=pts_field(1::2,:)
if(present(mysemb)) mysemb=semb_field
if(present(mydipxz)) mydipxz=p_xz
if(present(mydip_field_xzt)){
	 mydip_field_xzt=reshape(pxzt_field,(/dips_xz%n(1),dips_xz%n(2)/))
}
if(present(mywt)) mywt=wt_field
return_semb_2d=.true.
}


logical function semb_structures(mysemb,mydipsxz,mydipsyz,mywt){
type(sep3d),optional :: mysemb,mydipsxz,mydipsyz,mywt
semb_structures=.false.
if(present(mysemb)){
	if(.not. valid_structure(semb)){
		write(0,*) "semb structure not valid";return
	}
else {
 mysemb=semb
}
}
if(present(mydipsxz)){
	if(.not. valid_structure(dips_xz)){
		write(0,*) "dips_xz structure not valid";return
	}
else mydipsxz=dips_xz
}
if(present(mydipsyz)){
	if(.not. valid_structure(dips_yz)){
		write(0,*) "dips_yz structure not valid";return
	}
else mydipsyz=dips_yz
}
if(present(mywt)){
	if(.not. valid_structure(wt)){
		write(0,*) "wt structure not valid";return
	}
else mywt=wt
}

semb_structures=.true.
}


logical function calc_semblance_at_pts(npts){
integer :: npts
type(sep3d) :: moveout
integer, external :: auxin
real, allocatable :: myvel(:),gather(:,:),mysemb(:)
integer :: nv(3),ierr
integer :: i1,i2,i3,i4,ix,iy,iz,iout,mymax(1),i,nout
real :: header(4),maxme,mypct
real :: min_semb,max_semb,dsemb,min_tomo_pt_z,max_tomo_pt_z
logical :: keep
integer, external :: sep3d_set_ntraces,getch
integer :: nignore
real :: box_min_x(100),box_min_y(100),box_min_z(100)
real :: box_max_x(100),box_max_y(100),box_max_z(100)
real ::max_s




!SET UP SEMB and WT DATABASE
call init_sep3d(semb,"OUTPUT","FLOAT","HEADER",ctag="semb")
call axis_allocate(semb,2)
call key_allocate(semb,4)
semb%keytype="scalar_float"
semb%keyfmt="scalar_float"
semb%keyname(1)="s_x"
semb%keyname(2)="s_y"
semb%keyname(3)="s_z"
semb%keyname(4)="var"
semb%n(1:2)=(/1,npts/)
semb%label(2)="trace_in_bin"
semb%ndims=2
call sep3d_set_sep3d(semb)
call sep3d_grab_sep3d(semb%tag   ,semb)
call sep3d_write_description("semb",semb)
call init_sep3d(semb,wt,"OUTPUT",ctag="wt")
call sep3d_write_description("wt",wt)
call auxout("moveout")
call init_sep3d(semb,moveout,"OUTPUT",ctag="moveout")
moveout%n(1)=n_d_rms_semb
moveout%o(1)=0.;
moveout%d(1)=1.;
call sep3d_set_sep3d(moveout)
call sep3d_write_description("moveout",moveout)
allocate(semb_field(n_d_rms_semb))

box_min_x=mig%o(3)
box_max_x=mig%o(3)+mig%d(3)*(mig%n(3)-1)
if(is_2d){
box_min_y=-1
box_max_y=100
}
else{
box_min_y=mig%o(4)
box_max_y=mig%o(4)+mig%d(4)*(mig%n(4)-1)
}
nignore=getch("ignore_box_min_x","f",box_min_x)
nignore=getch("ignore_box_min_y","f",box_min_y)
nignore=getch("ignore_box_min_z","f",box_min_z)
nignore=getch("ignore_box_max_x","f",box_max_x)
nignore=getch("ignore_box_max_y","f",box_max_y)
nignore=getch("ignore_box_max_z","f",box_max_z)

iout=0
i3=-1;
i4=-1;
allocate(gather(mig%n(1),mig%n(2)))
call moveout_check_init()
pct_keep_semb=pct_keep_semb/100.
  call from_param("min_tomo_pt_z",min_tomo_pt_z,-10000.)
  call from_param("max_tomo_pt_z",max_tomo_pt_z,10000000.)
do i2=1,npts{
	if(verb && mod(i2,(npts/10))==1) write(0,*) "calculating semblance for ",i2," of ", npts
	ix=(pts_field(1,i2)-mig%o(3))/mig%d(3)+1.5
     if(sep3d_ndims(mig)==4) iy=(pts_field(2,i2)-mig%o(4))/mig%d(4)+1.5
      iy=1
	iz=(pts_field(3,i2)-mig%o(1))/mig%d(1)+1.5
  if(is_2d) iy=1
  if(i3!=ix || i4!= iy){
    i1=ix+(iy-1)*mig%n(3)
#    write(0,*) "seek check",i1,ix,iy,pts_field(:,i2)

    call sseek_block("mig",i1,size(gather)*4,0)
    call sreed("mig",gather,size(gather)*4)
    if(.not. change_semb_loc(pts_field(1:2))){
			write(0,*) "Trouble changing semblance location"
			return
		}
    i3=ix;
    i4=iy;
  }

  call calc_semblance(pts_field(:,i2),gather,semb_field,min_semb,max_semb)
  dsemb=(max_semb-min_semb)/n_d_rms_semb
  maxme=maxval(semb_field)
  mymax=maxloc(semb_field)
  mypct=(maxme-sum(semb_field)/size(semb_field))/(sum(semb_field)/size(semb_field))
  if(mypct > pct_keep_semb && maxme>min_keep_semb  &&
   min_tomo_pt_z < pts_field(3,i2) &&  max_tomo_pt_z >pts_field(3,i2))
{
   keep=.true.
   do i=1,nignore{
     if(pts_field(1,i2)>= box_min_x(i) && pts_field(1,i2) < box_max_x(i) &&
     pts_field(2,i2)>=box_min_y(i)&&pts_field(2,i2) < box_max_y(i) &&
     pts_field(3,i2)>box_min_z(i)&&pts_field(3,i2) < box_max_z(i) )keep=.false.
   }
    if(keep){
    header(1:3)=pts_field(:,i2)
    call srite("moveout",semb_field,size(semb_field)*4)
    call srite("semb",(mymax(1)-1)*dsemb+min_semb,4)
    call srite("wt",maxme,4)
    nout+=1
    max_s=(mymax(1)-1)*dsemb+min_semb
		call add_moveout(gather,pts_field(:,i2), max_s)
		header(4)=wt_calc_variance(max_s,min_semb,dsemb,n_d_rms_semb,semb_field)

    call sep_put_val_headers("semb",nout,1,header)
    call sep_put_val_headers("moveout",nout,1,header)
    call sep_put_val_headers("wt",nout,1,header)
	}
	else write(0,*) "killed  pt ",i2,mypct,maxme
  }
	else write(0,*) "killed  pt ",i2,mypct,maxme
}
call finish_moveout()
semb%ntraces=nout
moveout%ntraces=nout
wt%ntraces=nout
#inform the structures that we have written stuff
call sep3d_set_write_status(wt,.true.,.true.)
call sep3d_set_write_status(semb,.true.,.true.)
call auxputch("where","d",1,"semb")
call sep3d_set_write_status(moveout,.true.,.true.)

ierr= sep3d_set_ntraces(moveout%tag,nout)
call sep3d_rite_ntraces("moveout",semb%tag)
ierr= sep3d_set_ntraces(wt%tag,nout)
call sep3d_rite_ntraces("wt",semb%tag)

ierr= sep3d_set_ntraces(semb%tag,nout)
call auxputch("where","d",2,"semb")
call sep3d_rite_ntraces("semb",semb%tag)
call auxputch("where","d",3,"semb")
deallocate(gather,semb_field)
deallocate(pts_field)
calc_semblance_at_pts=.true.
}

subroutine expand_it(out_field,nout,oout,dout,in_field,nin,oin,din){
real :: in_field(:,:),out_field(:)
real :: oin(2),din(2),oout(2),dout(2)
real :: pos2_out,pos1_out
integer:: nin(2),nout(2)
integer :: i1,i2,b1,b2
real :: f1,f2

do i2=1,nout(2){
	pos2_out=(i2-1)*dout(2)+oout(2)
  f2=(pos2_out-oin(2))/din(2)+1
  if(f2 < 1.) { b2=1; f2=0.;}
  else if(f2>=nin(2)){ b2=nin(2)-1; f2=1.}
  else {b2=f2; f2-=b2;}
	do i1=1,nout(1){
		pos1_out=(i1-1)*dout(1)+oout(1)
 	 f1=(pos1_out-oin(1))/din(1)+1
 	 if(f1 < 1.) { b1=1; f1=0.;}
 	 else if(f1>=nin(1)){ b1=nin(1)-1; f1=1.}
 	 else {b1=f1; f1-=b1;}
   	out_field(i1+ nout(1) *(i2-1))=in_field(b1,b2)*(1.-f1)*(1.-f2)+ 
   	in_field(b1,b2+1)*(1.-f1)*(f2)+ 
   	in_field(b1+1,b2)*(f1)*(1.-f2)+ 
   	in_field(b1+1,b2+1)*(f1)*(f2)
	}
}

}


subroutine shrink_it(in_field,nin,oin,din,out_field,nout,oout,dout){
real :: in_field(:,:),out_field(:,:)
real :: oin(2),din(2),oout(2),dout(2)
integer:: nin(2),nout(2)
integer:: i1,i2,ia,ib,beg1,beg2,end1,end2
real :: count,pos1_in,pos2_in,pos1_out,pos2_out,numer,denom

do i2=1,nout(2){
	pos2_out=(i2-1)*dout(2)+oout(2)
	beg2=max(1,nint(((i2-2)*dout(2)+oout(2)-oin(2))/din(2)))
	end2=min(nin(2),nint(((i2)*dout(2)+oout(2)-oin(2))/din(2)))
	do i1=1,nout(1){
		pos1_out=(i1-1)*dout(1)+oout(1)
		beg1=max(1,nint(((i1-2)*dout(1)+oout(1)-oin(1))/din(1)))
		end1=min(nin(1),nint(((i1)*dout(1)+oout(1)-oin(1))/din(1)))
		numer=0; denom=0;
		do ib=beg2,end2{
			do ia=beg1,end1{
				denom+=1
				numer+=in_field(ia,ib)
			}
		}
!    write(0,*) "SHRINK CHECK",i1,i2,beg2,end2,pos2_out
    if(denom>0.) out_field(i1,i2)+=numer/denom
	}
}

}




logical function calc_dip_field(npts){
integer :: n(3),ns(3)
integer :: i1,i2,i3
integer :: b3,b2,b1,e3,e2,e1,k3,k2,k1
real, allocatable :: image(:,:,:)
real, allocatable :: coher(:,:,:),temp(:,:)
real, allocatable :: pxz(:,:,:),pyz(:,:,:),syz(:,:,:),sxz(:,:,:)
real, pointer :: res(:),dip(:)
integer, allocatable :: ilocs(:,:)
real :: os(3),ds(3),o(3),d(3)
integer,external :: auxin,sreed
integer     :: npts,ib,ia,ic,nbuf,i
type(sep3d) :: image_s
real        :: denom1,denom2,min_val,my_coh,my_amp
real        :: dx,dy,dz,x,y,z,tempr,pct
logical     :: have_pt(:,:,:)

if(.not. vel_z_tomo_structure(velz_s)){
  write(0,*) "trouble getting velz structure"
	return
}


calc_dip_field=.false.
if(-1==auxin("image")) {
	write(0,*) "trouble getting image file"
	return
}
call auxclose("image")
call init_sep3d("image",image_s,"INPUT")
if(is_2d){
	 n=(/image_s%n(1),image_s%n(2),1/)
	 o=(/image_s%o(1),image_s%o(2),0./)
	 d=(/image_s%d(1),image_s%d(2),1./)
	 ns=(/velz_s%n(1),velz_s%n(2),1/)
	 os=(/velz_s%o(1),velz_s%o(2),0./)
	 ds=(/velz_s%d(1),velz_s%d(2),1./)
}
else{
	  n=image_s%n
	  o=image_s%o
	  d=image_s%d
	  ns=velz_s%n
	  os=velz_s%o
	  ds=velz_s%d
}

allocate(image(n(1),n(2),n(3)))
allocate(coher(ns(1),ns(2),ns(3)))
allocate(sxz(ns(1),ns(2),ns(3)))
allocate(pxz(ns(1),ns(2),ns(3)))
if(.not. is_2d){
allocate(syz(ns(1),ns(2),ns(3)))
allocate(pyz(ns(1),ns(2),ns(3)))
}
if(4*size(image)!=sreed("image",image,size(image)*4)){
	write(0,*) "trouble reading image file"
	return
}
coher=0
sxz=0

if(verb) write(0,*) "BEFORE CALCULATE COHERENCY",ns
#CALCULATE SLOPES AND THE COHERENCY OF THE SLOPES
do i3=1,ns(3){
  k3=((os(3)+ds(3)*(i3-1))-o(3))/d(3)+1.5;
  if(k3>0 && k3 <= n(3)){
  b3=max(1,k3-nwind_dips(3))
  e3=min(n(3),k3+nwind_dips(3))
  do i2=1,ns(2){
    k2=((os(2)+ds(2)*(i2-1))-o(2))/d(2)+1.5
    if(k2>0 && k2 <= n(2)){
    b2=max(1,k2-nwind_dips(2))
    e2=min(n(2),k2+nwind_dips(2))
    do i1=1,ns(1){
      k1=((os(1)+ds(1)*(i1-1))-o(1))/d(1)+1.5
      if(k1>0 && k1 <= n(1)){
      b1=max(1,k1-nwind_dips(1))
      e1=min(n(1),k1+nwind_dips(1))
      call  puck_xz(image(b1:e1,b2:e2,b3:e3),coher(i1,i2,i3),sxz(i1,i2,i3))
      if(.not. is_2d)
        call  puck_yz(image(b1:e1,b2:e2,b3:e3),coher(i1,i2,i3),syz(i1,i2,i3))
    }}
  }
  }
}}

call srite("coher.H",coher,size(coher)*4);
if(.not. is_2d) syz=0.
if(verb) write(0,*) "BEFORE CALCULATE DIPS",ns
#CALCULATE SLOPES AND THE COHERENCY OF THE SLOPES
if(is_2d){
	allocate(res(n(1)*n(2)),dip(n(1)*n(2)))
	call  slope_init(n(1:2),d(1:2),verb)
	call expand_it(dip,n(1:2),o(1:2),d(1:2),
     sxz(:,:,1),ns(1:2),os(1:2),ds(1:2))
	call srite('icheck.H',image,size(image)*4)
	call slope_dir(reshape(image,(/size(image)/)),dip,res)
   call srite("medip2.H",dip,size(dip)*4)
!	call shrink_it(reshape(dip,(/n(1),n(2)/)),n(1:2),o(1:2),d(1:2),
!     sxz(:,:,1),ns(1:2),os(1:2),ds(1:2))
   call srite("medip.H",sxz,size(sxz)*4)
}
else{
	allocate(res(n(1)*n(2)),dip(n(1)*n(2)))
	call  slope_init(n(1:2),d(1:2),verb)
	do i3=20,ns(3){
		if(verb) write(0,*) "working on xz ",i3," of ",ns(3)
		i=max(1,min(n(3),nint(os(3)+ds(3)*(i3-1))) )
		call expand_it(dip,n(1:2),o(1:2),d(1:2),
      sxz(:,:,i3),ns(1:2),os(1:2),ds(1:2))
    call srite("sp2.H",dip,size(dip)*4)
		call slope_dir(reshape(image(:,:,i),(/size(image(:,:,i))/)),dip,res)
		res=maxval(abs(res))-abs(res)
    call srite("sp1.H",sxz(:,:,i3),size(sxz(:,:,i3))*4)
    sxz(:,:,i3)=0.
    call srite("sp2.H",dip,size(dip)*4)
		call shrink_it(reshape(dip,(/n(1),n(2)/)),n(1:2),o(1:2),d(1:2),
      sxz(:,:,i3),ns(1:2),os(1:2),ds(1:2))
    call srite("sp1.H",sxz(:,:,i3),size(sxz(:,:,i3))*4)
		if(verb) write(0,*) "working on xz ",i3," of ",ns(3),minval(dip),maxval(dip),minval(sxz),maxval(sxz)
	}
	call slope_clean()
	deallocate(res,dip)
	allocate(res(n(1)*n(3)),dip(n(1)*n(3)))
	call  slope_init(n(1:3:2),d(1:3:2),verb)
	do i2=1,ns(2){
		i=max(1,min(n(2),nint(os(2)+ds(2)*(i2-1))) )
		call expand_it(dip,n(1:3:2),o(1:3:2),d(1:3:2),
     syz(:,i2,:),ns(1:3:2), os(1:3:2),ds(1:3:2))
		call slope_dir(reshape(image(:,i,:),(/size(image(:,i,:))/)),dip,res)
    syz(:,i2,:)=0.
		call shrink_it(reshape(dip,(/n(1),n(3)/)),n(1:3:2),o(1:3:2),d(1:3:2),
     syz(:,i2,:),ns(1:3:2), os(1:3:2),ds(1:3:2))
		if(verb) write(0,*) "working on xz ",i2," of ",ns(2),minval(dip),maxval(dip),minval(syz),maxval(syz)
	}
	call slope_clean()
	deallocate(res,dip)
}
#now calculate coherency








		
if(verb) write(0,*) "finished calculating dips"
nbuf=1000
allocate(pts_field(3,1000))
i1=size(image)*pct_keep_image/100.
min_val=quantile(i1,reshape(abs(image),(/size(image)/)))

#CHOOSE THE PTS/RANGE 1
allocate(have_pt(ns(1),ns(2),ns(3)))
have_pt=.false.
do ic=1,nsect_dip_coher{
  pct=real(ic-1.)/real(nsect_dip_coher-1.)
  my_coh=0.01*(min_dip_coher*(pct)+(1.-pct)*max_dip_coher)
	i1=size(coher)*my_coh
  my_coh=quantile(i1,reshape(abs(coher),(/size(coher)/)))
  my_amp=0.01*(pct_keep_image*(pct)+(1.-pct)*90.)
  i1=size(image)*my_amp
  my_amp=quantile(i1,reshape(abs(image),(/size(image)/)))

  do i3=1,ns(3){
    b3=max(1,i3-min_pts_dist(3))
    e3=min(ns(3),i3+min_pts_dist(3))
   	y=os(3)+ds(3)*(i3-1)
    do i2=1,ns(2){
      b2=max(1,i2-min_pts_dist(2))
      e2=min(ns(2),i2+min_pts_dist(2))
    	x=os(2)+ds(2)*(i2-1)
      do i1=1,ns(1){
        b1=max(1,i1-min_pts_dist(1))
        e1=min(ns(1),i1+min_pts_dist(1))
      	z=os(1)+ds(1)*(i1-1)
        if(coher(i1,i2,i3)>my_coh && abs(image(i1,i2,i3)) > my_amp
         && .not. any(have_pt(b1:e1,b2:e2,b3:e3))){
            have_pt(i1,i2,i3)=.true.
            npts+=1
            pts_field(:,npts)=(/x,y,z/)
            if(npts+1==size(pts_field,2)){
              allocate(temp(3,nbuf)); temp=pts_field
              deallocate(pts_field); nbuf=nbuf*1.5
              allocate(pts_field(3,nbuf)); pts_field(:,:size(temp,2))=temp
              deallocate(temp)
            }
          }
        }
      }
		}
   if(verb) write(0,*) "have ",npts, " on pass ", ic,my_coh,my_amp
 }

deallocate(image)
#SORT THE POINTS
allocate(ilocs(3,npts));
do i2=1,npts{
   ilocs(:,i2) =nint(((/pts_field(3,i2),pts_field(1:2,i2)/)-
    (/os(1),os(2),os(3)/))/(/ds(1),ds(2),ds(3)/) +1.)
# write(0,*) "before sort",i2,ilocs(:,i2),pts_field(:,i2)
}
  call sort_it(ilocs,3,npts)
do i2=1,npts{
 pts_field(:,i2) = ((/ilocs(2:3,i2),ilocs(1,i2)/)-1)*(/ds(2:3),ds(1)/)+
  (/os(2:3),os(1)/)
# write(0,*) "after sort",i2,ilocs(:,i2),pts_field(:,i2)
}

#call srite('myc.H',pts_field(1::2,:),8*npts)

deallocate(ilocs)

if(verb) write(0,*) "Finished sorting points"



#SMOOTH THE DIPS
pxz=0
if(.not. is_2d) pyz=0.

do i3=1,ns(3){
	b3=max(1,i3-nsmooth_dips(3))
	e3=min(ns(3),i3+nsmooth_dips(3))
	do i2=1,ns(2){
		b2=max(1,i2-nsmooth_dips(2))
		e2=min(ns(2),i2+nsmooth_dips(2))
		do i1=1,ns(1){
			b1=max(1,i1-nsmooth_dips(1))
			e1=min(ns(1),i1+nsmooth_dips(1))
			denom1=0.;denom2=0.;
			do ic=b3,e3{
				dy=(ic-i3+.2)*ds(3)
				do ib=b2,e2{
					dx=(ib-i2+.2)*ds(2)
					do ia=b1,e1{
						dz=(ia-i1+.2)*ds(1)
						pxz(i1,i2,i3)+=sxz(ia,ib,ic)*coher(ia,ib,ic)**3/(dx*dx+dz*dz+dy*dy)
				  	denom1+=coher(ia,ib,ic)**3/(dx*dx+dz*dz+dy*dy)
            if(.not. is_2d){
							pyz(i1,i2,i3)+=syz(ia,ib,ic)*coher(ia,ib,ic)**3/(dx*dx+dz*dz+dy*dy)
				  		denom2+=coher(ia,ib,ic)**3/(dx*dx+dz*dz+dy*dy)
            }
					}
				}
			}
      if(denom1!=0.) pxz(i1,i2,i3)=pxz(i1,i2,i3)/denom1
			if(.not. is_2d && denom2!=0.) pyz(i1,i2,i3)=pyz(i1,i2,i3)/denom2
		}
	}
}
#write(0,*) "SUM COHERE",minval(pyz),maxval(pyz)
call sep3d_write_description("dips_xz",dips_xz)
if(.not. is_2d) call sep3d_write_description("dips_yz",dips_yz)
call srite("dips_xz",pxz*d(1)/ds(1)*ds(2)/d(2),size(pxz)*4)
deallocate(sxz,coher,pxz)
if(.not. is_2d){
	call srite("dips_yz",pyz*d(1)/ds(1)*ds(3)/d(3),size(pyz)*4)
	deallocate(syz,pyz)
}



#call sep3df_delete(image_s)
#call sep3df_delete(velz_s)
calc_dip_field=.true.
}

      

logical function write_params(){

write_params=.true.

call auxout("semb")
call auxout("dips_xz")
call init_sep3d(velz_s,dips_xz,"OUTPUT",ctag="dips_xz")
if(.not. is_2d) call  init_sep3d(velz_s,dips_yz,"OUTPUT",ctag="dips_yz")
#call auxinout("wt")


  call to_history("max_rms_err_pct",max_rms_err_pct,"semb")
  call to_history("n_d_rms_semb",n_d_rms_semb,"semb")
  call to_history("nsmooth_semb",nsmooth_semb,"semb")

  call to_history("nsect_dip_coher",nsect_dip_coher,"semb")
  call to_history("pct_keep_image",pct_keep_image,"semb")
  call to_history("min_keep_semb",min_keep_semb,"semb")
  call to_history("pct_keep_semb",pct_keep_semb,"semb")
  call to_history("max_dip_coher",max_dip_coher,"semb")
  call to_history("min_dip_coher",min_dip_coher,"semb")

  call to_history("nsmooth_dips",nsmooth_dips,"semb")
  call to_history("nwind_dips",nwind_dips,"semb")
  call to_history("min_pts_dist",min_pts_dist,"semb")


}



logical function check_params(){
integer :: ndims,tempi(3)
real :: tempr(3)
integer,external :: auxin
integer i1,i2,i3,i4,i5
ndims=sep3d_ndims(vel)

check_params=.true.
i1=auxin("semb")
i3=auxin("dips_xz")
if(.not. is_2d) i5=auxin("dips_yz")
else i5=1
i4=auxin("wt")
if(i1==-1 ||  i3==-1 || i4==-1 || i5==-1){
	check_params=.false.
}
else{
  tempr=-1
  call from_aux("semb","max_rms_err_pct",tempr(1),tempr(1))
  if(tempr(1)!=max_rms_err_pct) check_params=.false.
  call from_aux("semb","n_d_rms_semb",tempi(1),tempi(1))
  if(tempi(1)!=n_d_rms_semb) check_params=.false.
  call from_aux("semb","nsmooth_semb",tempi(1),tempi(1))
  if(tempi(1)!=nsmooth_semb) check_params=.false.

  call from_aux("semb","nsect_dip_coher",tempi(1),tempi(1))
  if(tempi(1)!=nsect_dip_coher) check_params=.false.
  call from_aux("semb","pct_keep_image",tempr(1),tempr(1))
  if(tempr(1)!=pct_keep_image) check_params=.false.
  call from_aux("semb","min_keep_semb",tempr(1),tempr(1))
  if(tempr(1)!=min_keep_semb) check_params=.false.
  call from_aux("semb","pct_keep_semb",tempr(1),tempr(1))
  if(tempr(1)!=pct_keep_semb) check_params=.false.
  call from_aux("semb","max_dip_coher",tempr(1),tempr(1))
  if(tempr(1)!=max_dip_coher) check_params=.false.
  call from_aux("semb","min_dip_coher",tempr(1),tempr(1))
  if(tempr(1)!=min_dip_coher) check_params=.false.

  call from_aux("semb","min_pts_dist",tempi,tempi)
  if(any(tempi(1:ndims)!=min_pts_dist)) check_params=.false.

  call from_aux("semb","nsmooth_dips",tempi,tempi)
  if(any(tempi(1:ndims)!=nsmooth_dips(1:ndims))) check_params=.false.
  call from_aux("semb","nwind_dips",tempi,tempi)
  if(any(tempi(1:ndims)!=nwind_dips(1:ndims))) check_params=.false.
}
   call auxclose("semb")
   call auxclose("dips_xz")
  call auxclose("wt")
  if(.not. is_2d) call auxclose("dips_yz")

}

logical function grab_pts_params(){
call from_param("verb",verb,.false.)
call from_param("max_rms_err_pct",max_rms_err_pct,10.)
call from_param("n_d_rms_semb",n_d_rms_semb,101)
call from_param("nsmooth_semb",nsmooth_semb,4)
call from_param("pct_keep_image",pct_keep_image,75.)
call from_param("pct_keep_semb",pct_keep_semb,300.)
call from_param("min_keep_semb",min_keep_semb,.1)
call from_param("min_dip_coher",min_dip_coher,.4)
call from_param("max_dip_coher",max_dip_coher,96.)
call from_param("nsect_dip_coher",nsect_dip_coher,4)
call from_param("nsmooth_dips",nsmooth_dips,(/2,2,2/))
call from_param("nwind_dips",nwind_dips,(/8,5,5/))
call from_param("min_pts_dist",min_pts_dist,(/5,5,5/))
grab_pts_params=.true.
}
integer function number_semblance_pts(){
number_semblance_pts=size(pts_field,2)
}





}
