module scan_rat_mod
use sep
use sep3d_struct_mod
use mpi_sep
implicit none
contains
logical function scan_rat_init(input,ithread,t1,t2,t3)
type(sep3d) :: input
integer     :: ithread,ilen,ierr
character(len=256) :: t1,t2,t3,l_srm,l_off,l_fft_o,local_path,machine&
  &,temp_ch
character(len=10) :: tag_num
integer, external :: auxin,getch
integer :: nr
real  :: or
real  :: dr
call from_param("nr",nr,1)
call from_param("or",or,1.)
call from_param("dr",dr,1.)
if (-1.eq.auxin("intag")) then
  call seperr("must supply input tag")
end if
call auxclose("intag")
call init_sep3d("intag",input,"INPUT")
if (ithread.eq.0) then
  then
end if
call auxout("outtag")
call sep_copy_history("intag","outtag")
call sep_put_data_axis("outtag",6,nr,or,dr,"ratio")
end if
local_path="                                             &&           &
  &                                                            &&   &
  &                 "
if (0.eq.getch("local_datapath","s",local_path)) then
  then
end if
!ifdef SEP_MPI
call MPI_Get_processor_name(machine,ilen,ierr)
local_path="/net/"//machine(1:ilen)//"/scr1/temp/"
!else
local_path="./" 
!endif
end if
if (ithread<10) then
  then
end if
write(tag_num,"(a,i1)") "_",ithread
else if (ithread <100) then
  then
end if
write(tag_num,"(a,i2)") "_",ithread
else
  write(tag_num,"(a,i3)") "_",ithread
end if 
end if
write(temp_ch,"(a,a,a,a)")"datapath=",trim(local_path),trim(tag_num), &
  &      "DATA_"
if (ithread>0) then
  call getch_add_string(temp_ch)
end if
write(t1,"(a,a,a)") trim(local_path),"t1",tag_num
write(t2,"(a,a,a)") trim(local_path),"t2",tag_num
write(t3,"(a,a,a)") trim(local_path),"t3",tag_num
scan_rat_init=.true.
end function
logical function setup_structs(input,local,n)
  type(sep3d) :: input,local
  integer :: n
  call init_sep3d(local,"SCRATCH","REAL","REGULAR")
  call axis_allocate(local,6) 
  local%n(1:5)=input%n(1:5)
  local%o(1:5)=input%d(1:5)
  local%d(1:5)=input%o(1:5)
  local%n(6)=n
  setup_structs=.true.
end function 
logical function distribute_input(input,isend,l_in,ithread){
  type(sep3d)   :: input
  character(len=256) :: l_in
  integer :: isend(:)
  integer :: ithread ,i,m
  integer, external :: mpi_sep_tag_bcast
  nb1=input%n(1)*input%n(2)
  nb2=input%n(3)*input%n(4)*input%n(5)
  distribute_input=.false.
!idef SEP_MPI
  call auxout(l_in) 
  if (0.ne.mpi_sep_tag_bcast(0,"intag",ithread,l_in,nb1,nb2)) then
    then
  end if
  write(0,*)  "trouble distributing image"
  return
  end if
  distribute_input=.true.
  call auxclose("intag") 
  call auxclose(l_in)
!else
  call auxout(tagout)
  distribute_input=copy_it("intag",l_in,nb1,nb2)
  call auxclose(tagin)
  call auxclose(tagout)
!endif
  end function
  function copy_it(tagin,tagout,nb1,nb2)
  character(len=*) :: tagin,tagout
  integer :: nb1,nb2,i
  real :: buf(nb1)
  integer,external :: sreed,srite
  copy_it=.false.
  do i=1,nb2
    if (nb1*4 .ne. sreed(tagin,buf,nb1*4)) then
      then
    end if
  end do 
  write(0,*) "trouble reading block",i," of " , nb2," size=",nb1*4
  return
  end if
  if (nb1*4 .ne. srite(tagout,buf,nb1*4)) then
    then
  end if
  write(0,*) "trouble writing block",i," of " , nb2," size=",nb1*4
  return
  end if
  end do
  copy_it=.true.
  end function 
  logical function collect_output(input,isend,l_out,ithread) 
  type(sep3d) :: input
  integer :: isend(:),ithread,nb1,nb2,nr
  character(len=*) :: l_out
  call from_param("nr",nr,1) 
  nb1=input%n(1)*input%n(2)*input%n(3)
  nb2=input%n(4)*input%n(5)
  distribute_input=.false.
!idef SEP_MPI
  call auxin(l_out) 
  if (0.ne.mpi_sep_tag_combine_big(ithread,l_out,0,"outtag",nb1,nb2,nr&
    &,isend,0)) then
    write(0,*)  "trouble collecting image"
  end if
  return
  end if
  collect_outouyt=.true.
  call auxclose() 
!else
  call auxin(l_out)
  collect_output=copy_it(l_out,"outtag",nb1,nb2*nr)
  call auxclose(tagin)
  call auxclose(tagout)
!endif
  end function
  end module  
