module wei_xmap
  !! X-domain mapping

  use wei_run
  use wei_down_type
  use wei_type
  !---------------
  implicit none

  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!
  type(wexmap), public :: xmap
  !! !!!!!!!!!!!!!!!!!!!!!!!!!!!!

contains
  !----------------------------------------------------------------
  subroutine weixmap_init()
    integer :: imx,imy,ihx,ihy
    integer :: er
#ifdef DEBUG
    character(len=128), parameter :: unit='weixmap_init'
    if(run%debug) call in(unit)
#endif

    !! mx
    allocate(xmap%mx(down%amx%n),stat=er)
    if(er/=0) call seperr('cant allocate mx')
    do imx=1,down%amx%n
       xmap%mx(imx) = down%amx%o + (imx-1)* down%amx%d
    end do

    !! my
    allocate(xmap%my(down%amy%n),stat=er)
    if(er/=0) call seperr('cant allocate my')
    do imy=1,down%amy%n
       xmap%my(imy) = down%amy%o + (imy-1)* down%amy%d
    end do

    !! hx
    allocate(xmap%hx(down%ahx%n),stat=er)
    if(er/=0) call seperr('cant allocate hx')
    do ihx=1,down%ahx%n
       xmap%hx(ihx) = down%ahx%o + (ihx-1)* down%ahx%d
    end do

    !! hy
    allocate(xmap%hy(down%ahy%n),stat=er)
    if(er/=0) call seperr('cant allocate hy')
    do ihy=1,down%ahy%n
       xmap%hy(ihy) = down%ahy%o + (ihy-1)* down%ahy%d
    end do

    !! sx,rx
    allocate(xmap%sx(down%amx%n,down%ahx%n),stat=er)
    if(er/=0) call seperr('cant allocate sx')
    allocate(xmap%rx(down%amx%n,down%ahx%n),stat=er)
    if(er/=0) call seperr('cant allocate rx')
    do ihx=1,down%ahx%n
       do imx=1,down%amx%n
          xmap%sx(imx,ihx) = xmap%mx(imx) + xmap%hx(ihx)
          xmap%rx(imx,ihx) = xmap%mx(imx) - xmap%hx(ihx)
       end do
    end do

    !! sy,ry
    allocate(xmap%sy(down%amy%n,down%ahy%n),stat=er)
    if(er/=0) call seperr('cant allocate sy')
    allocate(xmap%ry(down%amy%n,down%ahy%n),stat=er)
    if(er/=0) call seperr('cant allocate ry')
    do ihy=1,down%ahy%n
       do imy=1,down%amy%n
          xmap%sy(imy,ihy) = xmap%my(imy) + xmap%hy(ihy)
          xmap%ry(imy,ihy) = xmap%my(imy) - xmap%hy(ihy)
       end do
    end do

#ifdef DEBUG
    if(run%debug) call out(unit)
#endif
  end subroutine weixmap_init
  !----------------------------------------------------------------
end module wei_xmap
